"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceVariables = replaceVariables;
exports.createBindings = createBindings;
exports.termToString = void 0;

var _ldflex = require("ldflex");

const {
  termToString
} = _ldflex.SparqlHandler.prototype;
exports.termToString = termToString;

function replaceVariables(template, terms) {
  for (const name in terms) template = template.replace(new RegExp("_:".concat(name), 'g'), termToString(terms[name]));

  return template;
} // Imitate Comunica's response for bindings as a Immutable.js object.


function createBindings(...items) {
  return {
    size: items.length,
    values: () => ({
      next: () => ({
        value: items.shift()
      })
    })
  };
}